<?php

/** Copyright 2010 Tactical FLEX
 *
 * Aanval 6
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_BPUList() {

	$xml = "<document>\n";
		
		$xml .= "\t<data>\n";
		
		
		$data[] = array(
						"short" => "A",
						"name" => "Import",
						"description" => "Import and normalization of incoming event data");

		$data[] = array(
						"short" => "B",
						"name" => "Core",
						"description" => "Primary functions and operations of the console");

		$data[] = array(
						"short" => "C",
						"name" => "Index",
						"description" => "Creation and management of event index data");

		$data[] = array(
						"short" => "D",
						"name" => "Search",
						"description" => "Processing of event search requests");

		$data[] = array(
						"short" => "E",
						"name" => "Report",
						"description" => "Processing of event report requests");
		
		foreach ($data as $bpu) {
			
			if ($tmp = @file("../../logs/bpu" . strtoupper($bpu['short']) . ".sts")) {
			
				$data1 = explode(",", trim($tmp[0]));
				$diff = $data1[1] - $data1[0];
				
				$lastRun = date("r", consoleTimeConversion($data1[1]));
			
			} else {
			
				$diff = -1;
				$lastRun = "never";
			
			}
			
			$xml .= "\t\t<bpu>\n";
			$xml .= "\t\t\t<short>" . $bpu['short'] . "</short>\n";
			$xml .= "\t\t\t<name>" . $bpu['name'] . "</name>\n";
			$xml .= "\t\t\t<description>" . $bpu['description'] . "</description>\n";
			$xml .= "\t\t\t<lastrun>" . $lastRun . "</lastrun>\n";
			$xml .= "\t\t\t<lastlength>" . $diff . "</lastlength>\n";
			$xml .= "\t\t</bpu>\n";
		
		}
		
		$xml .= "\t</data>\n";
	
	$xml .= "</document>\n";

	return $xml;	
	
}  

function prv_BPULogData() {

	$bpu = sanitize("bpu");

    $logFile = "../../logs/bpu" . strtoupper($bpu) . ".log";

	if (@file_exists($logFile)) {
		
		$data = file_get_contents($logFile);
		
	} else {
	
		$data = "BPU Log does not yet exist (check that your background processors (BPU's) have been started).";
	
	}
	
	$xml .= "<document>\n";
		
		$xml .= "\t<data><![CDATA[$data]]></data>\n";
	
	$xml .= "</document>\n";

	return $xml;	
	
}  

?>