<?php

/** Copyright 2010 Tactical FLEX
 *
 * Aanval 6
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_dataStoreList() {
	global $idsDB;

	$num = sanitize("num");

	$cnt = 0;
	$totalEvents = 0;
	$totalStores = 0;

	$xml = "<document>\n";

	$xml .= "\t<data>\n";

	$q = $idsDB->query("SHOW TABLES LIKE 'idsDataStore%Master'");
	while ($row = mysql_fetch_array($q)) {

		$tmp = explode("_", $row[0]);

		// ensure newly deleted stores are not included in the listing (even if not technically deleted yet)

		if (in_array($tmp[1], explode(",", ops("storeDeletion")))) continue;

		$storeArray[] = $tmp[1];

		$totalStores++;

	}

	rsort($storeArray);

	foreach ($storeArray as $store) {

		$cnt++;
		$storeName = "Unnamed Datastore";

		$xml .= "\t\t<dataStore>\n";
		
		$xml .= "\t\t\t<store>" . $store . "</store>\n";

		$q1 = $idsDB->query("SELECT name FROM idsDataStore WHERE store = '" . $store . "'");
		while ($row1 = mysql_fetch_array($q1)) {
		
			$storeName = $row1[0];
		
		}
		
		$idsQueryA = $idsDB->query("SELECT count(*) FROM idsDataStore_" . $store . "_Master AS mas");
    	while (list($res) = mysql_fetch_row($idsQueryA)) {
    		$eventTotal = $res;
		}

		$totalEvents += $eventTotal;

		$xml .= "\t\t\t<events>$eventTotal</events>\n";

		$xml .= "\t\t\t<storeName>" . $storeName . "</storeName>\n";
		
		if (login("activeSearchStore") == $store) {
		
			$xml .= "\t\t\t<active>1</active>\n";
		
		} else {
		
			$xml .= "\t\t\t<active>0</active>\n";
			
		}
		
		$xml .= "\t\t</dataStore>\n";
			
		if ($cnt >= $num) break;
			
	}

	$xml .= "\t\t<rotationType>" . ops("site_dataStoreRotationType") . "</rotationType>\n";
	$xml .= "\t\t<rotationEvents>" . ops("site_dataStoreRotationEvents") . "</rotationEvents>\n";
	$xml .= "\t\t<rotationDays>" . ops("site_dataStoreRotationDays") . "</rotationDays>\n";
	$xml .= "\t\t<compressionEnabled>" . ops("site_dataStoreCompression") . "</compressionEnabled>\n";

	$xml .= "\t\t<activeDataStore>" . ops("site_activeDataStore") . "</activeDataStore>\n";

	$xml .= "\t\t<stores>$totalStores</stores>\n";
	$xml .= "\t\t<events>$totalEvents</events>\n";

	$xml .= "\t</data>\n";

	$xml .= "</document>\n";

	return $xml;	
}

function prv_dataStoreUpdate() {
	global $idsDB;

	$store = sanitize("store");
	if (!$store) return;

	$name = sanitize("name");

	$q = $idsDB->query("SELECT id FROM idsDataStore WHERE store = '$store'");
	while ($row = mysql_fetch_array($q)) {
	
		$valid = true;
	
	}

	if ($valid) {
	
		$q = $idsDB->query("update idsDataStore set name = '$name' where store = '$store'");
	
	} else {
	
		$q = $idsDB->query("insert into idsDataStore (store, name) values ('$store', '$name')");
	
	}

	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_dataStoreSettingsUpdate() {
	global $idsDB;

	$rotateday = sanitize("rotateday");
	$rotateevent = sanitize("rotateevent");
	$rotatedisabled = sanitize("rotatedisabled");
	$rotatedaynum = sanitize("rotatedaynum");
	$rotateeventnum = sanitize("rotateeventnum");

	if ($rotateday == 1) {
	
		$rotationType = 1;
		
	} else if ($rotateevent == 1) {
	
		$rotationType = 2;
		
	} else {
	
		$rotationType = 0;
		
	}

	ops("site_dataStoreCompression", $compression);
	ops("site_dataStoreRotationType", $rotationType);
	ops("site_dataStoreRotationDays", $rotatedaynum);
	ops("site_dataStoreRotationEvents", $rotateeventnum);

	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_setActiveSearchStore() {
	global $idsDB;

	$store = sanitize("store");
	if (!$store) return;
	
	login("activeSearchStore", $store);

	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;

}

function prv_forceIndexReProcess() {

	$store = sanitize("store");
	if (!$store) return;

	if (ops("indexReprocess") == 0) {
		ops("indexReprocess", $store);
	}
	
	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
	
}

function prv_forceDatastoreRotate() {

	ops("site_dataSwitch", 1);

	$dataStoreObj = new dataStore();

	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
	
}

function prv_forceDatastoreDelete() {

	$store = sanitize("store");
	if (!$store) return;

	if (strlen(ops("storeDeletion")) >= 1) {

		$delArray = explode(",", trim(ops("storeDeletion")));
	
	}

	$delArray[] = $store;

	ops("storeDeletion", implode(",", $delArray));
	
	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
	
}

?>

