<?php

/** Copyright 2010 Tactical FLEX
 *
 * Aanval 5
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_frequentEventsData() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$type = sanitize("type");
	if (!$type) $type = 1;
	
	$type == 1 ? $order = "DESC" : $order = "ASC";

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$total = 0;

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$result = $idsDB->query("SELECT count(mas.id) AS cnt, evt.signatureName AS signame, evt.signature as sigid FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') GROUP BY evt.signatureName ORDER BY cnt $order LIMIT $num");

	} else {

		// Standard Results

		$result = $idsDB->query("SELECT count(mas.id) AS cnt, evt.signatureName AS signame, evt.signature as sigid FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") GROUP BY evt.signatureName ORDER BY cnt $order LIMIT $num");
	
	}

	while ($row = mysql_fetch_assoc($result)) {

		$xml .= "\t\t<data>\n";

		foreach ($row as $key => $val) {
	
			$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
				
		}
		
		$total += $row["cnt"];
		
		$xml .= "\t\t</data>\n";		

	}
	
	$xml .= "\t<total><![CDATA[$total]]></total>\n";
	
	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_frequentOffendersData() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$type = sanitize("type");
	if (!$type) $type = 1;

	$type == 1 ? $order = "DESC" : $order = "ASC";

	$resolve = sanitize("resolve");
	if (!$resolve) $resolve = 0;

	$resolve == 0 ? $resolve = false : $resolve = true;

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$total = 0;
	
	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.sip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') group by evt.sip order by cnt $order limit $num");
	
	} else {
	
		// Standard Results
	
		$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.sip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") group by evt.sip order by cnt $order limit $num");
	
	}

	while ($row = mysql_fetch_assoc($result)) {

		$xml .= "\t\t<data>\n";

		$row["host"] = doHostnameLookup($row["ip"], $resolve);

		foreach ($row as $key => $val) {
	
			$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
				
		}
		
		$total += $row["cnt"];
		
		$xml .= "\t\t</data>\n";

	}
	
	$xml .= "\t<total><![CDATA[$total]]></total>\n";
	
	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_frequentPortsData() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$type = sanitize("type");
	if (!$type) $type = 1;

	$direction = sanitize("direction");
	if (!$direction) $type = 2;

	$protocol = sanitize("protocol");
	if (!$protocol) $protocol = 6;

	$type == 1 ? $order = "DESC" : $order = "ASC";
	$direction == 1 ? $direction = "sport" : $direction = "dport";

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$total = 0;
	
	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$result = mysql_query("SELECT count(mas.id) AS cnt, evt.$direction AS port FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') AND evt.protocol = '$protocol' group by evt.$direction order by cnt $order limit $num");
	
	} else {
	
		// Standard Results
	
		$result = mysql_query("SELECT count(mas.id) AS cnt, evt.$direction AS port FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") AND evt.protocol = '$protocol' group by evt.$direction order by cnt $order limit $num");
	
	}

	while ($row = mysql_fetch_assoc($result)) {

		$xml .= "\t\t<data>\n";

		foreach ($row as $key => $val) {
	
			$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
				
		}
		
		$total += $row["cnt"];
		
		$xml .= "\t\t</data>\n";

	}
	
	$xml .= "\t<total><![CDATA[$total]]></total>\n";
	
	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_frequentTargetsData() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$type = sanitize("type");
	if (!$type) $type = 1;
	
	$type == 1 ? $order = "DESC" : $order = "ASC";

	$resolve = sanitize("resolve");
	if (!$resolve) $resolve = 0;

	$resolve == 0 ? $resolve = false : $resolve = true;

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$total = 0;
	
	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
		
		$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.dip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') group by evt.dip order by cnt $order limit $num");
	
	} else {
	
		// Standard Results
	
		$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.dip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") group by evt.dip order by cnt $order limit $num");
	
	}

	while ($row = mysql_fetch_assoc($result)) {

		$xml .= "\t\t<data>\n";

		$row["host"] = doHostnameLookup($row["ip"], $resolve);

		foreach ($row as $key => $val) {
	
			$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
				
		}
		
		$total += $row["cnt"];
		
		$xml .= "\t\t</data>\n";

	}
	
	$xml .= "\t<total><![CDATA[$total]]></total>\n";
	
	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_iPhoneFrequentEvents() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$xml = "<document>\n";

	if (ops("site_iPhoneAccess") != 1) {
	
		$xml .= "\t<data>\n";
		
		$xml .= "\t\t<cnt>0</cnt>\n";
		$xml .= "\t\t<signame>iPhone Access Disabled</signame>\n";
		$xml .= "\t\t<sigid>0</sigid>\n";
		$xml .= "\t\t<classname>iPhone Access Disabled</classname>\n";

		$xml .= "\t</data>\n";	
	
	} else {
	
		if (ops("site_custom_snortGroup") == 1) {
	
			// Custom Grouping Results
		
			$result = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName as signame, evt.signature as sigid, evt.className as classname FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') group by evt.signatureName order by cnt desc limit $num");
	
		} else {
	
			// Standard Results
	
			$result = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName as signame, evt.signature as sigid, evt.className as classname FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") group by evt.signatureName order by cnt desc limit $num");
		
		}
	
		while ($row = mysql_fetch_assoc($result)) {
	
			$xml .= "\t\t<data>\n";
	
			foreach ($row as $key => $val) {
		
				$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
					
			}
			
			$xml .= "\t\t</data>\n";
	
		}

	}
	
	$xml .= "</document>\n";

	return $xml;
}

function prv_iPhoneFrequentOffenders() {
    global $idsDB;

	$num = sanitize("num");
	if (!$num) $num = 100;

	$xml = "<document>\n";

	if (ops("site_iPhoneAccess") != 1) {
	
		$xml .= "\t<data>\n";
		
		$xml .= "\t\t<cnt>0</cnt>\n";
		$xml .= "\t\t<ip>iPhone Access Disabled</ip>\n";
		$xml .= "\t\t<host>iPhone Access Disabled</host>\n";

		$xml .= "\t</data>\n";	
	
	} else {

		if (ops("site_custom_snortGroup") == 1) {
	
			// Custom Grouping Results
		
			$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.sip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["sensors"] . "','+','[+]'), ' ', ''), ',', '|') group by evt.sip order by cnt desc limit $num");
		
		} else {
		
			// Standard Results
		
			$result = mysql_query("SELECT count(mas.id) as cnt, INET_NTOA(evt.sip) as ip FROM idsDataStore_" . $_SESSION["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["sensors"] . ") group by evt.sip order by cnt desc limit $num");
		
		}
	
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	
			$xml .= "\t\t<data>\n";
	
			$row["host"] = doHostnameLookup($row["ip"]);
	
			foreach ($row as $key => $val) {
		
				$xml .= "\t\t\t<$key><![CDATA[$val]]></$key>\n";
					
			}
			
			$xml .= "\t\t</data>\n";
			
	
		}

	}
	
	$xml .= "</document>\n";

	return $xml;
}

?>