<?php

/** Copyright 2009 Tactical FLEX
 *
 * Aanval 5
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */
 
// Set to HTML format prior to initializing (prevents XML heading from returning)
$_GET["format"] = 2; 
 
include "initialize.php";

function pub_checkMessages() {
	global $idsDB;

	// Returns the next waiting message in order

    $id = sanitize("id");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
			commonOperations($id);
    		
    		heartbeatUpdate($id);
    		
    		$out = sensorMessage($id);
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;
	
}

function pub_snortStatus() {
	global $idsDB;

	// Updates status of snort process from smt

    $id = sanitize("id");
    $data = sanitize("data");

    if (!$id) {
    
    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
			commonOperations($id);
    		
    		heartbeatUpdate($id);
    	
			if ($data == 1) {
			
				$idsDB->query("update idsSensor set status = '1', lastStatusCheck = '" . time() . "', countStatusFailure = '0' where smtid = '$id'");
				
			} else {
			
				$idsDB->query("update idsSensor set status = '0', lastStatusCheck = '" . time() . "', countStatusFailure = (countStatusFailure + 1) where smtid = '$id'");
				
			}

    	}
    
    }

	if (!$out) $out = 1;

	return $out;
	
}

function pub_sensorUptime() {
	global $idsDB;

	// Receives uptime from smt

    $id = sanitize("id");
    $data = sanitize("data");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;

}

function pub_sendConf() {
	global $idsDB;

	// Receives and saves snort conf from smt

    $id = sanitize("id");
    $file = sanitize("file");
    $data = getVar("data");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
	        if ($fp = @fopen("../../smt/sensorData/$id/$file", "w")) {
	
	        	fputs ($fp, urlBase64_decode($data));
	
	            fclose($fp);
	
				$idsDB->query("update idsSensor set confFile = '$file' where smtid = '$id'");
				
	        } else {
	        
				errorLog("File: '../../smt/sensorData/$id/$file' could not be opened for writing");
	        
	        }
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;
	
}

function pub_getConf() {
	global $idsDB;

	// Sends snort conf to smt

    $id = sanitize("id");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
	        $idsQueryA = $idsDB->query("select confFile from idsSensor where smtid = '$id'");
			for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
				$confFile = $row[0];
			}
	    	
	        $data = @file_get_contents("../../smt/sensorData/$id/$confFile");
	        
	        if ($data) {
	        
		        $out = urlBase64_encode($data);
		        
	        } else {
	        
	        	$out = 0;
	        	
	        }
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;

}

function pub_sendRule() {
	global $idsDB;

	// Receives and saves snort rule from smt

    $id = sanitize("id");
    $file = sanitize("file");
    $data = getVar("data");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
			if (!file_exists("../../smt/snortRules/smt-$id")) {
				@mkdir("../../smt/snortRules/smt-$id");
				@mkdir("../../smt/snortRules/smt-$id/rules");
			}
	
			// Write snort rules to package directory
	        if ($fp = @fopen("../../smt/snortRules/smt-$id/rules/$file", "w")) {
	
	        	fputs ($fp, urlBase64_decode($data));
	
	        	// Close file handle
	            fclose($fp);
	            
	        } else {
	        
				errorLog("File: '../../smt/snortRules/smt-$id/rules/$file' could not be opened for writing");
	        
	        }
	
			// Create and store policy file
			
			$ruleFile = @file("../../smt/snortRules/smt-$id/rules/$file");
			
			foreach ($ruleFile as $line) {
			
				unset($array, $sid, $gid, $rev, $foundSignature, $newSignatureID);
			
				if (strstr($line, "alert") && strstr($line, "sid:")) {

					# Signature line

					$line = trim($line);
					if (strstr(substr($line, 0, 1), "#")) $line = substr($line, 1);
					$line = trim($line);
		
					preg_match("/sid:\s*[0-9]+/", $line, $match);
					$sid = trim(str_replace("sid:", "", $match[0]));
		
					preg_match("/gid:\s*[0-9]+/", $line, $match);
					$gid = trim(str_replace("gid:", "", $match[0]));
					if (!$gid) $gid = 1;

					preg_match("/rev:\s*[0-9]+/", $line, $match);
					$rev = trim(str_replace("rev:", "", $match[0]));
					if (!$rev) $rev = 1;

					preg_match("/classtype:\s?([^;]*);/", $line, $match);
					$class = trim(str_replace("classtype:", "", $match[0]));
					$class = str_replace(";", "", $class);
					$class = addslashes($class);
				
					preg_match("/msg:\s?\"([^\"]*)\"/", $line, $match);
					$msg = trim(str_replace("msg:", "", $match[0]));
					$msg = str_replace("\"", "", $msg);
					$msg = addslashes($msg);
					
					$data = addslashes($line);
				
	   	 			$idsQueryA = $idsDB->query("SELECT * from idsSignatures WHERE sid = '$sid' AND gid = '$gid' ORDER BY rev DESC LIMIT 1");
					while ($row = mysql_fetch_assoc($idsQueryA)) {
		
						# Found existing signature
						
						$foundSignature = true;
						
						// If revision is greater, we'll insert into db and update policies if applicable						
						
						if ($rev > $row["rev"]) {
						
							// New revision of signature available

							// Insert
															
			   	 			$idsQueryA = $idsDB->query("INSERT INTO idsSignatures (sid, gid, rev, msg, class, file, source, data, intime) VALUES ('$sid', '$gid', '$rev', '$msg', '$class', '$file', '$source', '$data', '" . time() . "')");

							$newSignatureID = mysql_insert_id();
							
							// Update any matching id's in the policy index

							if (ops("site_policyRevisionUpdate") == 1) {

				   	 			$idsDB->query("UPDATE idsSignaturePolicyIndex SET sid = '$newSignatureID' WHERE sid = '" . $row["id"] . "'");
				   	 			
				   	 			$update_count++;
				   	 			
				   	 		}

							// Delete existing signature
							
							if (ops("site_signatureRevisionReplace") == 1) {

				   	 			$idsDB->query("DELETE FROM idsSignatures WHERE id = '" . $row["id"] . "'");

				   	 			$delete_count++;

							}								

#								echo "INSERT REVISION: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
							
							$revision_count++;
							
			   	 			$rev_array[] = $newSignatureID;
			   	 			
							// Signature ID array for policy index
							$sigPolicy_array[] = $newSignatureID;
							
						} else {

#								echo "SKIPPING: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
						
							$skip_count++;
							
							// Signature ID array for policy index
							$sigPolicy_array[] = $row["id"];
							
						}

					}
					
					if (!$foundSignature) {
					
						// Signature not found in database
						
		   	 			$idsDB->query("INSERT INTO idsSignatures (sid, gid, rev, msg, class, file, source, data, intime) VALUES ('$sid', '$gid', '$rev', '$msg', '$class', '$file', '$source', '$data', '" . time() . "')");
						
						$newSignatureID = mysql_insert_id();
						
#							echo "INSERT: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
						
						$insert_count++;
						
		   	 			$insert_array[] = $newSignatureID;
						
						// Signature ID array for policy index
						$sigPolicy_array[] = $newSignatureID;
						
					}
					
			
				} else {
				
					# Not a signature line
				
				}

			}			
		    		
    	}
    	
    	if ($sigPolicy_array) {
    	
	        $idsQueryA = $idsDB->query("SELECT id, confPolicy FROM idsSensor WHERE smtid = '$id'");
			while ($row = mysql_fetch_assoc($idsQueryA)) {
			
				// Policy found
			
				if ($row["confPolicy"] > 0) {
	
					$policyFound = $row["confPolicy"];

				}
			
			}
			
			if ($policyFound) {

				// Insert signatures into policy
				
				foreach ($sigPolicy_array as $sig) {
					
					$idsDB->query("INSERT INTO idsSignaturePolicyIndex (pid, sid) VALUES ('" . $policyFound . "', '$sig')");
				
				}
			
			} else {

				// Create new policy for this sensor

				$idsDB->query("INSERT INTO idsSensorPolicy (name) VALUES ('SMT Policy - $id')");
			
				$newPolicyID = mysql_insert_id();
				
				$idsDB->query("UPDATE idsSensor SET confPolicy = '$newPolicyID' WHERE smtid = '$id'");
				
				foreach ($sigPolicy_array as $sig) {
					
					$idsDB->query("INSERT INTO idsSignaturePolicyIndex (pid, sid) VALUES ('" . $newPolicyID . "', '$sig')");
				
				}
				
			}
    	
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;

}

function pub_getRules() {
	global $idsDB;

	// Sends list of rule files to smt

    $id = sanitize("id");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
	        $q = $idsDB->query("SELECT confFile, confPolicy FROM idsSensor WHERE smtid = '$id'");
			while ($row = mysql_fetch_assoc($q)) {
			
				$confFile = $row["confFile"];
				$policy = $row["confPolicy"];
				
			}    	
	    	
	        if ($rulesDir = @dir("../../smt/policyData/$policy/")) {

		        while ($file = $rulesDir->read()) {
		            if ($file != "." && $file != ".." && $file != "$confFile") {
		            
		                $out .= "$file\n";
		                
		            }
		        }

	        } else {
	        
	        	$out = 0;
	        
	        }
	        
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;

}

function pub_getRule() {
	global $idsDB;

	// Sends rule file to smt

    $id = sanitize("id");
    $rule = sanitize("rule");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
    		$policy = getPolicyBySMTID($id);
    		
	        $data = file_get_contents("../../smt/policyData/$policy/$rule");
	        
	        $out = urlBase64_encode($data);
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;
	
}

function pub_SMTUpdate() {
	global $idsDB;

	// Sends smt.php to smt

    $id = sanitize("id");
    $rule = sanitize("rule");

    if (!$id) {

    	$out = "Sensor management identification was not received. Exiting.";
    	
    } else {
    
    	if (verifySMTID($id) != 1) {
    	
	    	$out = "Sensor management identification failure. Exiting.";
    	
    	} else {
    	
    		// Function content
    		
    		heartbeatUpdate($id);
    		
	        $data = file_get_contents("../../contrib/smt/smt.php");
	        
	        $out = urlBase64_encode($data);
    		
    	}
    	
    }

	if (!$out) $out = 1;

	return $out;

}

function verifySMTID($id) {
	global $idsDB;

	$q = $idsDB->query("SELECT id FROM idsSensor WHERE smtid = '$id'");
	while ($row = mysql_fetch_assoc($q)) {
	
		return 1;
		
	}
	
	return 0;
	
}

function getPolicyBySMTID($id) {
	global $idsDB;

	$q = $idsDB->query("SELECT confPolicy FROM idsSensor WHERE smtid = '$id'");
	while ($row = mysql_fetch_assoc($q)) {
		
		$policy = $row["confPolicy"];
		
	}
	
	if (!$policy) {
	
		return 0;
	
	} else {

		return $policy;
	
	}
	
	
}

function commonOperations($id) {

	// If the direction we are looking for is actually a file then unlink it
	if (@is_file("../../smt/sensorData/$id")) @unlink("../../smt/sensorData/$id");
	
	// Create SMT ID directory
    @mkdir("../../smt/sensorData/$id");

}

function heartbeatUpdate($id) {
	global $idsDB;

	$idsDB->query("UPDATE idsSensor SET hb = '" . time() . "', hbcount = (hbcount + 1) WHERE smtid = '$id'");

}

function sensorMessage($smtid) {
    global $idsDB;

    $idsQueryA = $idsDB->query("SELECT id, confPolicy FROM idsSensor WHERE smtid = '$smtid' AND enabled = 1 AND module = 1");
	while ($row = mysql_fetch_assoc($idsQueryA)) {
	
        $sid = $row["id"];
        $confPolicy = $row["confPolicy"];
        
    }

    if (!$sid) return;

    $idsQueryA = $idsDB->query("SELECT id, message FROM idsSensorManageMessages WHERE sid = '$sid' AND enabled = 1 ORDER BY issued LIMIT 1");
    while (list($d_id, $d_message) = mysql_fetch_row($idsQueryA)) {
        $id = $d_id;
        $message = $d_message;
    }

    if ($message) {
        
        $idsQueryA = $idsDB->query("UPDATE idsSensorManageMessages SET enabled = 0, received = '" . time() . "' WHERE id = '$id'");
        
        // Perform pre-pickup operations
        
        if ($message == "SNORTRULESGET") {
        
			if ($confPolicy > 0) {

				// Prepare signatureIndex for incoming signatures
				
				$idsDB->query("DELETE FROM idsSignaturePolicyIndex WHERE pid = '" . $confPolicy . "'");
				
			}
        
        }
        
    } else {
        $message = "SNORTSTATUS";
    }

    return "MSG::" . $message;
}

function urlBase64_decode($string) {
 
	$string = str_replace('-', '+', $string);
	$string = str_replace('_', '/', $string);
	$string = str_replace('.', '=', $string);

	return base64_decode($string);
}

function urlBase64_encode($string) {

	$string = base64_encode($string);
	$string = str_replace('+', '-', $string);
	$string = str_replace('/', '_', $string);
	$string = str_replace('=', '.', $string);

	return $string;
}

function smtSignatureImporter($pkg, $source) {
	global $idsDB;
	
	$path = "../../smt/snortRules/ptmp/";

	$insert_count = 0;
	$revision_count = 0;
	$skip_count = 0;
	$update_count = 0;
	$delete_count = 0;
	
	$ruleDirectoryArray = array("rules", "so_rules", "preproc_rules");
	
	// Uncompress and remove files	
	@exec("gunzip -c $path/$pkg | tar -xvf - -C $path");
	@unlink($path . $pkg);

	foreach ($ruleDirectoryArray as $ruleDir) {

		unset($rules_array);
	
		// rules	
		if ($thisDir = @dir($path . "/$ruleDir/")) { 
			while ($file = $thisDir->read()) {
				if ($file != "." && $file != "..") {
					if (substr($file, -6) == ".rules") {
					
						if (!in_array($file, array("deleted.rules", "xyz.rules"))) {
							
							$rules_array[] = $file;
							
						}
					
					}
				}
			}
	    }
	    
		foreach ($rules_array as $file) {
	    
			if ($content = @file("$path/$ruleDir/$file")) {
			
				foreach ($content as $line) {
				
					unset($array, $sid, $gid, $rev, $foundSignature, $newSignatureID);
				
					if (strstr($line, "alert") && strstr($line, "sid:")) {
	
						# Signature line
	
						$line = trim($line);
						if (strstr(substr($line, 0, 1), "#")) $line = substr($line, 1);
						$line = trim($line);
			
						preg_match("/sid:\s*[0-9]+/", $line, $match);
						$sid = trim(str_replace("sid:", "", $match[0]));
			
						preg_match("/gid:\s*[0-9]+/", $line, $match);
						$gid = trim(str_replace("gid:", "", $match[0]));
						if (!$gid) $gid = 1;
	
						preg_match("/rev:\s*[0-9]+/", $line, $match);
						$rev = trim(str_replace("rev:", "", $match[0]));
						if (!$rev) $rev = 1;
	
						preg_match("/classtype:\s?([^;]*);/", $line, $match);
						$class = trim(str_replace("classtype:", "", $match[0]));
						$class = str_replace(";", "", $class);
						$class = addslashes($class);
					
						preg_match("/msg:\s?\"([^\"]*)\"/", $line, $match);
						$msg = trim(str_replace("msg:", "", $match[0]));
						$msg = str_replace("\"", "", $msg);
						$msg = addslashes($msg);
						
						$data = addslashes($line);
					
		   	 			$idsQueryA = $idsDB->query("SELECT * from idsSignatures WHERE sid = '$sid' AND gid = '$gid' ORDER BY rev DESC LIMIT 1");
						while ($row = mysql_fetch_assoc($idsQueryA)) {
			
							# Found existing signature
							
							$foundSignature = true;
							
							// If revision is greater, we'll insert into db and update policies if applicable						
							
							if ($rev > $row["rev"]) {
							
								// New revision of signature available

								// Insert
																
				   	 			$idsQueryA = $idsDB->query("INSERT INTO idsSignatures (sid, gid, rev, msg, class, file, source, data, intime) VALUES ('$sid', '$gid', '$rev', '$msg', '$class', '$file', '$source', '$data', '" . time() . "')");

								$newSignatureID = mysql_insert_id();
								
								// Update any matching id's in the policy index

								if (ops("site_policyRevisionUpdate") == 1) {

					   	 			$idsDB->query("UPDATE idsSignaturePolicyIndex SET sid = '$newSignatureID' WHERE sid = '" . $row["id"] . "'");
					   	 			
					   	 			$update_count++;
					   	 			
					   	 		}

								// Delete existing signature
								
								if (ops("site_signatureRevisionReplace") == 1) {

					   	 			$idsDB->query("DELETE FROM idsSignatures WHERE id = '" . $row["id"] . "'");

					   	 			$delete_count++;

								}								

#								echo "INSERT REVISION: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
								
								$revision_count++;
								
				   	 			$rev_array[] = $newSignatureID;
								
							} else {
	
#								echo "SKIPPING: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
							
								$skip_count++;
								
							}

						}
						
						if (!$foundSignature) {
						
							// Signature not found in database
							
			   	 			$idsDB->query("INSERT INTO idsSignatures (sid, gid, rev, msg, class, file, source, data, intime) VALUES ('$sid', '$gid', '$rev', '$msg', '$class', '$file', '$source', '$data', '" . time() . "')");
							
							$newSignatureID = mysql_insert_id();
							
#							echo "INSERT: $file - SID:$sid GID:$gid REV:$rev CLASS:$class\n";
							
							$insert_count++;
							
			   	 			$insert_array[] = $newSignatureID;
							
						}						
				
					} else {
					
						# Not a signature line
					
					}
	
				}
			
			}
	
		}
		
	}
	
    procWrite("B", "Processing Count - New: $insert_count");
    procWrite("B", "Processing Count - Revisions: $revision_count");
    procWrite("B", "Processing Count - Skipped: $skip_count");
    procWrite("B", "Processing Count - Deleted: $delete_count");
    procWrite("B", "Processing Count - Policies Updated: $update_count");
	
	if (($insert_count + $revision_count + $skip_count + $update_count + $delete_count) > 0) {
	
	    // Trigger Sensors to retreive new signatures
	    
	    $idsQueryA = $idsDB->query("SELECT id, name FROM idsSensor WHERE confPolicy > 0 AND module = 1");
		while ($row = mysql_fetch_assoc($idsQueryA)) {
	    
	        $idsQueryB = $idsDB->query("INSERT INTO idsSensorManageMessages (sid, message, enabled, issued) VALUES ('" . $row["id"] . "', 'SNORTRULESSEND', '1', '" . time() . "')");
		    procWrite("B", " . Message SNORTRULESSEND posted for sensor: " . $row["name"]);
	        
	        $idsQueryB = $idsDB->query("INSERT INTO idsSensorManageMessages (sid, message, enabled, issued) VALUES ('" . $row["id"] . "', 'SNORTRESTART', '1', '" . time() . "')");
		    procWrite("B", " . Message SNORTRESTART posted for sensor: " . $row["name"]);
	        
	    }
	
		sendSignatureUpdateEmail($insert_array, $rev_array, $insert_count, $revision_count, $skip_count, $update_count, $delete_count);
		
	}
	
}

?>